﻿#target indesign
//LabelGraphics.jsx (Modified)
//An InDesign CS3 JavaScript
// Проверена работоспособность в InDesign CC 2024
/*  
@@@BUILDINFO@@@ "LabelGraphics.jsx" 1.1.0 6-June-2008
*/
//Adds labels to the graphics in the active document.
/* This sample script has been modified. The modications are listed here: option added to create a label from clipboard data,
	dropdown menu added to apply a swatch to the caption frame. This script can now apply lables to just the selected graphics
	if you have one or more images selected. Otherwise it will apply the lables to all graphics in the document.	The hieght of the 
	caption frame is determined by the amount of text, and paragraph style applied. the width of the caption frame is
	determined by the width of the graphic it is under. Setting the caption height in the dialog box has been removed, as it is no
	longer needed.
	*/
// Модификация скрипта 1 октября 2024 г. Б. Кащеев: 
// 1. Добавлена возможность выводить дату создания;
// 2. Реализована работа со стилями, находящимися в папках и подпапках;
// 3. При повторных запусках скрипта сохраняются последние введенные значения.

var myLoadFile = true;
main();

//=============================================================\\
function main(){
	if(app.documents.length != 0){
		if(app.documents.item(0).allGraphics.length != 0){
			myDisplayDialog();
		}
		else{
			alert("Document contains no graphics.");
		}
	}
	else{
		alert("Please open a document and try again.");
	}
}


//=============================================================\\
function myDisplayDialog(){
	var myLabelWidth = 100;
	var myStyleNames = myGetParagraphStyleNames();
    var myData =[];
 // Чтение данных из ф-ла
    myData =  loadOldDannyeFromFile ();

    if(myLoadFile != true) myData =[4,0,0,0]; // Присваиваются значения по умолчанию
    
	var mySwatchNames = myGetSwatchNames();
	var myDialog = app.dialogs.add({name:"LabelGraphics (mod)"});
	with(myDialog.dialogColumns.add()){
		//Label type
		with(dialogRows.add()){
			with(dialogColumns.add()){
				staticTexts.add({staticLabel:"Label Type", minWidth:myLabelWidth});
			}
			with(dialogColumns.add()){
				var myLabelTypeDropdown = dropdowns.add({stringList:["File name", "File path", "XMP description", "XMP author","Creation Date", "Paste from clipboard"], selectedIndex: parseInt(myData[0])});
			}
		}
		with(dialogRows.add()){
			with(dialogColumns.add()){
				staticTexts.add({staticLabel:"Label Offset", minWidth:myLabelWidth});
			}
			with(dialogColumns.add()){
				var myLabelOffsetField = measurementEditboxes.add({editValue: parseInt(myData[1])});
			}
		}
		//Style to apply
		with(dialogRows.add()){
			with(dialogColumns.add()){
				staticTexts.add({staticLabel:"Label Style", minWidth:myLabelWidth});
			}
			with(dialogColumns.add()){
				var myLabelStyleDropdown = dropdowns.add({stringList:myStyleNames, selectedIndex: parseInt(myData[2])});
			}
		}	
		//Swatch to apply
		with(dialogRows.add()){
			with(dialogColumns.add()){
				staticTexts.add({staticLabel:"Apply swatch", minWidth:myLabelWidth});
			}
			with(dialogColumns.add()){
				var mySwatchDropdown = dropdowns.add({stringList:mySwatchNames, selectedIndex: parseInt(myData[3])});
			}
		}	
	
	}


//=============================================================\\
	var myResult = myDialog.show();
	if(myResult == true){
		var myLabelType = myLabelTypeDropdown.selectedIndex;
		var myLabelHeight = 24; // A generic label height that will be adjusted later
		myPasteFailure = false; 
		var myLabelOffset = myLabelOffsetField.editValue;
		var myLabelStyle = myStyleNames[myLabelStyleDropdown.selectedIndex]; // 
		var mySwatch = mySwatchNames[mySwatchDropdown.selectedIndex];
        // передаём выбранные значения в масив данных.
         myData = [myLabelTypeDropdown.selectedIndex, myLabelOffsetField.editValue,myLabelStyleDropdown.selectedIndex,mySwatchDropdown.selectedIndex];
		myDialog.destroy();
         saveDataToFile(myData);
		var myOldXUnits = app.documents.item(0).viewPreferences.horizontalMeasurementUnits;
		var myOldYUnits = app.documents.item(0).viewPreferences.verticalMeasurementUnits;
		app.documents.item(0).viewPreferences.horizontalMeasurementUnits = MeasurementUnits.points;
		app.documents.item(0).viewPreferences.verticalMeasurementUnits = MeasurementUnits.points;

		try{
			myAddLabels(myLabelType, myLabelHeight, myLabelOffset, myLabelStyle, mySwatch); 
			}
			catch(e){
				alert("Unable to add lables. " + e);	
				}
		
		try{	
			resizeOverset() ;
			}
			catch(e){
				alert("Unable to correct overset text. " + e);
				}
			
			if (myPasteFailure == true){
				alert("Unable to paste from clipboard.");
				}
			
		app.documents.item(0).viewPreferences.horizontalMeasurementUnits = myOldXUnits;
		app.documents.item(0).viewPreferences.verticalMeasurementUnits = myOldYUnits;
	}
	else{
		myDialog.destroy();
	}
}


//=============================================================\\
function myAddLabels(myLabelType, myLabelHeight, myLabelOffset, myLabelStyleName, mySwatchName){ 
	var myDocument = app.documents.item(0);
	myStoriesArray = new Array();
	
	if (app.selection.length == 0) // If nothing is selected apply caption to all graphics in the document
		{
			var myConfirmation = confirm("Add captions to all images in the document?", false, "LabelGraphics.jsx" );
			if (myConfirmation == true)
				{
					var myGraphics = myDocument.allGraphics;
					}
			}
		else	
			{ // If graphics are selected, just add captions to the selected items, as long as they are rectangles(image frames)
			var myConfirmation = true;
			var mySelections = app.selection;
			myGraphics = new Array();
				
			for(i = 0; i < mySelections.length; i++){
					if(mySelections[i] == "[object Rectangle]"){   //Check to make sure selection only includes rectangles
							myGraphics.push(mySelections[i].allGraphics[0]);
							}	
						else{
							//alert("Objects other than graphics were selected!");
							//Nothing happens if you don't select at least one graphic
							} 
					} 
				} 
			
       //myLabelStyle = myDocument.paragraphStyles.item(myLabelStyleName);
       myLabelStyle = getParagraphStyleByName(myLabelStyleName);
	  mySwatch = myDocument.swatches.item(mySwatchName);
	
	if (myConfirmation == true){	
		for(var myCounter = 0; myCounter < myGraphics.length; myCounter++){
			try{
				myAddLabel(myDocument, myGraphics[myCounter], myLabelType, myLabelHeight, myLabelOffset, myLabelStyle, mySwatch, myStoriesArray);
				}
				catch(e){};
		}
	}
}


//=============================================================\\
function myAddLabel(myDocument, myGraphic, myLabelType, myLabelHeight, myLabelOffset, myLabelStyle, mySwatch, myStoriesArray){ 
	var myLabel;
	var myLink = myGraphic.itemLink;
	var myPasteFromClipboard = false;
	//Create the label layer if it does not already exist. 
	var myLabelLayer = myDocument.layers.item("labels"); 
	try{ 
 		myLabelLayer.name; 
	} 
 	catch (myError){ 
  		myLabelLayer = myDocument.layers.add({name:"labels"}); 
	} 
	//Label type defines the text that goes in the label.
	switch(myLabelType){
		//File name
		case 0:
			myLabel = myLink.name;
			break;
		//File path
		case 1:
			myLabel = myLink.filePath;
			break;
		//XMP description
		case 2:
			try{
				myLabel = myLink.linkXmp.description;
			}
			catch(myError){
				myLabel = "No description available.";
			}
			break;
		//XMP author
		case 3:
			try{
				myLabel = myLink.linkXmp.author
			}
			catch(myError){
				myLabel = "No author available.";
			}
			break;
          //creationDate
          case 4:
			try{
                // дата в таком формате: Wed Apr 27 2016 14:55:19 GMT+0300
                myDate = myLink.linkXmp.creationDate.toString().split(" ") ;
                myLabel = myDate[2] +" " + myDate[1] + " " +myDate[3];
			}
			catch(myError){
				myLabel = "No date available.";
			}
			break;
		//Paste from the clipboard
		case 5:
			try{
				myPasteFromClipboard = true;
			}
			catch(myError){
				myLabel = "No clipboard data available.";
			}
			break;
	}
	var myFrame = myGraphic.parent;
	myX1 = myFrame.geometricBounds[1]; 
	myY1 = myFrame.geometricBounds[2] + myLabelOffset; 
	myX2 = myFrame.geometricBounds[3]; 
	myY2 = myY1 + myLabelHeight;
	
	if (myPasteFromClipboard ==true)
	{
		try{	
			var myTextFrame = myFrame.parent.textFrames.add(myLabelLayer, undefined, undefined,{geometricBounds:[myY1, myX1, myY2, myX2]}); 
			myTextFrame.insertionPoints.item(0).select(); 
			app.paste();	
			}
			catch(e){
				myTextFrame.remove();
				myPasteFailure = true;
				}
		}	
	else{
		var myTextFrame = myFrame.parent.textFrames.add(myLabelLayer, undefined, undefined,{geometricBounds:[myY1, myX1, myY2, myX2], contents:myLabel}); 
		}
	
	myTextFrame.textFramePreferences.firstBaselineOffset = FirstBaseline.leadingOffset; 
	myTextFrame.paragraphs.item(0).appliedParagraphStyle = myLabelStyle;

		
	myTextFrame.fillColor = mySwatch;
	myFrameParentStory = myTextFrame.parentStory;
	myStoriesArray.push(myFrameParentStory);
	
}



//=============================================================\\
// это старая функция, теперь не используется (Б. Кащеев)
//function myGetParagraphStyleNames(){
//	var myStyleNames = app.documents.item(0).paragraphStyles.everyItem().name;
//	return myStyleNames;
//}

function myGetParagraphStyleNames()
{
var result = [];    
var myParagraphStyles = app.activeDocument.allParagraphStyles;
var myParagraphStyleName, obj;
for(var i=0; i < myParagraphStyles.length ; i++)
{
    myParagraphStyleName = myParagraphStyles[i].name;
    obj = myParagraphStyles[i];
    while(obj.parent instanceof ParagraphStyleGroup)
    {
        myParagraphStyleName = obj.parent.name + ":" + myParagraphStyleName;
        obj = obj.parent;        
    }
    result.push(myParagraphStyleName);
 } // for
result.shift(); // удаление стиля No Paragraph Style
return result;
} // fnc

function myGetSwatchNames(){
	var mySwatchNames = app.documents.item(0).swatches.everyItem().name;
	return mySwatchNames;
}

function getParagraphStyleByName(myStyleName)
{
var myParagraphStyles = app.activeDocument.allParagraphStyles;
var myParagraphStyleName, obj;
    for(var i=0; i < myParagraphStyles.length ; i++)
    {
        myParagraphStyleName = myParagraphStyles[i].name;
        obj = myParagraphStyles[i];
        while(obj.parent instanceof ParagraphStyleGroup)
        {
            myParagraphStyleName = obj.parent.name + ":" + myParagraphStyleName;
            obj = obj.parent;        
        }
        if(myParagraphStyleName == myStyleName)  return myParagraphStyles[i];
     } // for
    
} // fnc

function resizeOverset() {
	           for (var j = myStoriesArray.length - 1; j >= 0; j--) {
                    myLastFrame = myStoriesArray[j].texts[0].parentTextFrames[myStoriesArray[j].texts[0].parentTextFrames.length - 1];
                    
					myNewY2 = myLastFrame.geometricBounds[3]; //get the width of the text frame before doing fit()
					
					myLastFrame.fit(FitOptions.FRAME_TO_CONTENT);
					
					myNewY1 = myLastFrame.geometricBounds[1]; 
					myNewX1 = myLastFrame.geometricBounds[2];
					myNewX2 = myLastFrame.geometricBounds[0];	

					myLastFrame.geometricBounds = [myNewX1, myNewY1, myNewX2, myNewY2]; // reset the width to before fit() was ran

            }
} 

function  loadOldDannyeFromFile ()
{
        var myScriptFile = myGetScriptPath();
        //alert(myScriptFile);
        var iniFileInfo  = "labelGraphics(mod).ini";
        var myScriptFolder = decodeURI(myScriptFile.path);
        var filePath = decodeURI(myScriptFolder + "/" + iniFileInfo); 
        var f = new File (filePath);
        var DannyeFromFile = [];

       if (f.exists) {
            try {
                f.open('r')
                DannyeFromFile = f.read().split('\n');            
            }
            catch(errOpen) {
                if ( confirm("Ошибка открытия файла. Продолжаем без данных этого файла?")) { // Да или Нет
                myLoadFile = false;
                return null;
                }
                else { 
                    alert("Прервано пользователем - конец работы. [1]"); // <<< это Миша добавил. Просто exit() быть не должно.                    
                    exit();                    
                    }
            }
            
        } // if
        else {
            if( confirm("Файл с результатами последнего запуска скрипта не найден. Продолжаем без него?") ) {
                myLoadFile = false;
                return null;
            }
            else { 
                alert("Прервано пользователем - конец работы. [2]"); // <<< это Миша добавил. Просто exit() быть не должно.                
                exit();                 
                }
            
        } // else
// Обрабатываем ситуацию, когда файл с данными оказывается пустой, размером ноль байтов 
    if(DannyeFromFile[0] =="" && DannyeFromFile.length ==1)
    {
          if( confirm("Вероятно, файл с результатами последнего запуска скрипта поврежден. Продолжаем без него?") ) {
                    myLoadFile = false;
                    return null;
                }
    else { 
        // Пользователь отказался работать со скриптом
        alert("Прервано пользователем - конец работы. [3]"); // <<< это Миша добавил.         
        exit();         
        }
    } //if(DannyeFromFile[0]

return DannyeFromFile;
} 


function saveDataToFile(DannyeFromFile)
{
    var myScriptFile = myGetScriptPath();
    var iniFileInfo  = "labelGraphics(mod).ini";
    var myScriptFolder = decodeURI(myScriptFile.path);
    var filePath = decodeURI(myScriptFolder + "/" + iniFileInfo); 
    var f = new File (filePath); 
    
    var result = f.open("w");
    	if (!result) {
		alert("Невозможно открыть файл для записи!");
        
		exit();
	}
    f.encoding = "UTF-8";
    for (var i =0; i<DannyeFromFile.length; i++ )
    {
       f.write(DannyeFromFile[i] + "\n");
    }
    
    f.close();  
 }
 
 function myGetScriptPath() { 
	try{
		return app.activeScript;
	}
	catch(myError){
		return File(myError.fileName);
	}
} //myGetScriptPath()